#! /usr/bin/env python3

import sys
import os
import subprocess
from shutil import which

def printUsageAndExit() :
  print("USAGE : %s file.conllu embeddingsSize outputFile"%sys.argv[0], file=sys.stderr)
  exit(1)

if __name__ == "__main__" :
  if len(sys.argv) != 4 :
    printUsageAndExit()

  pathToFile = sys.argv[1]
  embeddingsSize = int(sys.argv[2])
  splited = os.path.splitext(pathToFile)
  target = sys.argv[3]

  if which("word2vec") is None or which("udpipe") is None :
    exit(0)

  p = subprocess.Popen("udpipe --output=horizontal none %s > in.text && rm in.text"%pathToFile, stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell=True)
  p.wait()

  args = [
    "word2vec",
    "-cbow 0",
    "-size %s"%embeddingsSize,
    "-window 10",
    "-negative 5",
    "-hs 0",
    "-sample 1e-1",
    "-threads 4",
    "-binary 0",
    "-iter 15",
    "-min-count 2",
    "-train in.text",
    "-output %s"%target,
  ]

  p = subprocess.Popen(" ".join(args), stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell=True)
  p.wait()

